package com.bank;

import org.springframework.test.AbstractTransactionalDataSourceSpringContextTests;

public class AccountServiceTestIntegrated extends AbstractTransactionalDataSourceSpringContextTests
{
    private AccountService _accountService;

    public void setAccountService(AccountService accountService)
    {
        _accountService = accountService;
    }

    protected String[] getConfigLocations()
    {
        return new String[] {"applicationcontext.xml"};
    }

    public void testGetAccount()
    {
        Account account = _accountService.getAccount(1);
        assertEquals(1, account.getId());
        assertEquals(5000, account.getBalance());
    }

    public void testTransferFund()
    {
        Account account1 = _accountService.getAccount(1);
        Account account2 = _accountService.getAccount(2);

        assertEquals(5000, account1.getBalance());
        assertEquals(10000, account2.getBalance());

        _accountService.transferFund(1,  2,  1000);

        account1 = _accountService.getAccount(1);
        account2 = _accountService.getAccount(2);

        assertEquals(4000, account1.getBalance());
        assertEquals(11000, account2.getBalance());
    }
}
